; Winsock API for PureBasic written by Steve Bigras.
; An example to establish a TCP connection

IncludeFile "WinsockFunctions.pb"
wsVer=InitWinsock()
If wsVer=0
   MessageRequester("Error","Problem initializing Winsock",0):End
  Else
   Debug "Winsock "+Str(wsVer & 255)+"."+Str((wsVer/256) & 255)+" started"
EndIf

inputwnd=OpenWindow(1,200,400,320,40,#PB_Window_SystemMenu,"Input window")
CreateGadgetList(inputwnd):StringGadget(0,10,10,300,20,"")

popserver=ConnectTCP("pop.bellnet.ca",110,thrID)

Repeat
we=WindowEvent():ww=EventWindowID()
If ww=1
   If we=#PB_Event_CloseWindow:TerminateWinsock():End:EndIf
   If we=256:If EventwParam()=13:a$=GetGadgetText(0)+Chr(13)+Chr(10)
      SendTCP(Sockets(popserver)\sck,@a$,Len(a$)):SetGadgetText(0,""):EndIf
      If EventwParam()=27:TerminateWinsock():End:EndIf
   EndIf
EndIf

For gg=1 To ProcessWinsockEvents()
 Select SockEvents(gg)\EventID
  Case #CONNECTION_ESTABLISHED
   sckidx=SockEvents(gg)\idx
   Debug "connected to "+Sockets(sckidx)\remotehost+", port "+Str(Sockets(sckidx)\remoteport)+", your local port "+Str(Sockets(sckidx)\localport)
  Case #INCOMING_DATA
   sckidx=SockEvents(gg)\idx
   ll=RetrieveData(SockEvents(gg)\sck,strAddr.l,sckidx)
   If ll>0
      a$=PeekS(strAddr)
      b$=ReplaceString(a$,chr$(13)+chr$(10),"") ;trim CrLF from received line
      Debug b$
   EndIf   
  Case #CONNECTION_CLOSING
   sckidx=SockEvents(gg)\idx
   Debug Sockets(sckidx)\remotehost+" closed the connection"
   Debug "closed socket slot "+Str(sckidx)
   CloseSocket(SockEvents(gg)\sck)
 EndSelect
 Next
Delay(10)
ForEver
; ExecutableFormat=Windows
; EOF