; Winsock API for PureBasic written by Steve Bigras.
; An example to wait for incoming connections
; using two diffrent ports.

IncludeFile "WinsockFunctions.pb"
wsVer=InitWinsock()
If wsVer=0
   MessageRequester("Error","Problem initializing Winsock",0):End
  Else
   Debug "Winsock "+Str(wsVer & 255)+"."+Str((wsVer/256) & 255)+" started"
EndIf

sckidx1=ListenTCP(6666):If sckidx1<1:Debug "error listening on port 6666":EndIf
sckidx2=ListenTCP(7777):If sckidx2<1:Debug "error listening on port 7777":EndIf


Repeat
ww=WindowEvent();:If ww=#PB_Event_CloseWindow:TerminateWinsock():End:EndIf
For gg=1 To ProcessWinsockEvents()
 Select SockEvents(gg)\EventID
  Case #INCOMING_DATA
   sckidx=SockEvents(gg)\idx
   ll=RetrieveData(SockEvents(gg)\sck,strAddr.l,sckidx)
   If ll>0
      a$=PeekS(strAddr)
      Debug "Data received from "+Sockets(sckidx)\remotehost+", port "+Str(Sockets(sckidx)\LocalServerPort)
      Debug a$
   EndIf   
  Case #CONNECTION_CLOSING
   sckidx=SockEvents(gg)\idx
   Debug Sockets(sckidx)\remotehost+" closed the connection on localport "+Str(Sockets(sckidx)\localserverport)
   Debug "closed socket slot "+Str(sckidx)
   CloseSocket(SockEvents(gg)\sck)
  Case #INCOMING_CONNECTION
   MyServerPort.l=Sockets(SockEvents(gg)\idx)\localserverport
   sckidx=AcceptConnection(SockEvents(gg)\sck)
   ;RefuseConnection(SockEvents(gg)\sck)
   If sckidx>0
      Debug "Connection accepted on port "+Str(MyServerPort)+" from "+Sockets(sckidx)\remotehost
      a$="Welcome!"+chr$(13)+chr$(10)
      SendTCP(Sockets(sckidx)\sck,@a$,Len(a$))
   EndIf
   res=ListenTCP(MyServerPort) ;Listen again to accept more incoming connections for that port
 EndSelect
 Next
Delay(10)
ForEver
; ExecutableFormat=Windows
; EOF