; Winsock API for PureBasic written by Steve Bigras.
; An example on how to use UDP.

IncludeFile "WinsockFunctions.pb"
wsVer=InitWinsock()
If wsVer=0
   MessageRequester("Error","Problem initializing Winsock",0):End
  Else
   Debug "Winsock "+Str(wsVer & 255)+"."+Str((wsVer/256) & 255)+" started"
EndIf

inputwnd=OpenWindow(1,200,400,320,40,#PB_Window_SystemMenu,"Input window")
CreateGadgetList(inputwnd):StringGadget(0,10,10,300,20,"")

udpidx=InitUDP(9999)
If udpidx>0:Debug "UDP bind on port 9999 successful":Else:Debug "Unable to bind port 9999, address in use?":EndIf

Repeat
we=WindowEvent():ww=EventWindowID()
If ww=1
   If we=#PB_Event_CloseWindow:TerminateWinsock():End:EndIf
   If we=256
      If EventwParam()=13:a$=GetGadgetText(0)+Chr(13)+Chr(10)
         SendUDP(Sockets(udpidx)\sck,@a$,Len(a$),"127.0.0.1",9999) ;send text locally
         SetGadgetText(0,"")
      EndIf
      If EventwParam()=27:TerminateWinsock():End:EndIf
   EndIf
EndIf

For gg=1 To ProcessWinsockEvents()
 Select SockEvents(gg)\EventID
  Case #INCOMING_DATA
   sckidx=SockEvents(gg)\idx
   ll=RetrieveData(SockEvents(gg)\sck,strAddr.l,sckidx)
   If ll>0
      a$=PeekS(strAddr)
      b$=ReplaceString(a$,chr$(13)+chr$(10),"") ;trim CrLF from received line
      Debug b$
   EndIf   
 EndSelect
 Next
Delay(10)
ForEver
; ExecutableFormat=Windows
; EOF